<?php
if (!defined('OLDPAL_VIRT_PHP')) {
define('OLDPAL_VIRT_PHP', null);



//
// +----------------------------------------------------------------------+
// | PHP version 4.0                                                      |
// +----------------------------------------------------------------------+
// +----------------------------------------------------------------------+
// | Authors: Jacky Ko
// +----------------------------------------------------------------------+
//
// $Id: oldpal_virt.php,v 1.1 2003/10/19 08:01:11 root Exp root $
//
// Database independent query interface definition for Oldpal PHP
// extension.
//

include_once('DB.php');
include_once('DB/oldpal_common.php');
include_once('DB/virt.php');

class DB_oldpal_virt extends DB_virt
{
	var $oldpal_owner = '';
	var $oldpal_service = '';
	var $oldpal_dbid = '';  // Dummy
	var $oldpal_dbtype = '';
	var $oldpal_host = '';
	var $oldpal_database = '';
	var $SQLCommand = '';

	var $debugLevel = 0;

	function DB_oldpal_virt()
	{
		$this->DB_virt();
	}


	function connect($dsn = '', $persistent = false, $owner = '', $service = '')
	{
if ($this->debugLevel) printf("<b>function</b> %s::connect<br>\n", get_class($this));
		global $BeeCroft;
		if (isset($BeeCroft))
		{
			list ($this->oldpal_owner, $this->oldpal_service)
				= $BeeCroft->getOwnerService();
			list ($this->oldpal_dbid, $this->oldpal_dbtype, $this->oldpal_host, $this->oldpal_database, $AuthUsername, $AuthPassword)
				= $BeeCroft->getAllDataInfo();
		} else
		{
			$this->oldpal_owner = $owner;
			$this->oldpal_service = $service;

			/*
			if(is_array($dsn))
			{
				$dsninfo = &$dsn;
			} else
			{
				$dsninfo = DB::parseDSN($dsn);
			}
			if (!$dsninfo || !$dsninfo['phptype'])
			{
				return $this->raiseError(); 
			}
			$this->oldpal_dbtype = $dsninfo['phptype'];
			$this->oldpal_host = $dsninfo['hostspec'] ? $dsninfo['hostspec'] : 'localhost';
			$this->oldpal_database = $dsninfo['database'];
			$AuthUsername = $dsninfo['username'];
			$AuthPassword = $dsninfo['password'];
			 */
		}

		/*
if ($this->debugLevel)
{
	printf("\$oldpal_owner = [%s]<br>\n", $this->oldpal_owner);
	printf("\$oldpal_service = [%s]<br>\n", $this->oldpal_service);
	printf("\$oldpal_dbid = [%s]<br>\n", $this->oldpal_dbid);
	printf("\$oldpal_dbtype = [%s]<br>\n", $this->oldpal_dbtype);
	printf("\$oldpal_host = [%s]<br>\n", $this->oldpal_host);
	printf("\$oldpal_database = [%s]<br>\n", $this->oldpal_database);
	printf("\$AuthUsername = [%s]<br>\n", $AuthUsername);
	printf("\$AuthPassword = [***]<br>\n", $AuthPassword);
}

		$connect_function = $persistent ? 'mysql_pconnect' : 'mysql_connect';
		if ($this->oldpal_host && $AuthUsername && $AuthPassword)
		{
if ($this->debugLevel) printf("<b>function</b> %s::connect host($this->oldpal_host) user($AuthUsername) password(***)<br>\n", get_class($this));
			$conn = $connect_function($this->oldpal_host, $AuthUsername, $AuthPassword);
		} elseif ($this->oldpal_host && $AuthUsername)
		{
if ($this->debugLevel) printf("<b>function</b> %s::connect host($this->oldpal_host) user($AuthUsername)<br>\n", get_class($this));
			$conn = $connect_function($this->oldpal_host, $AuthUsername);
		} else
		{
if ($this->debugLevel) printf("<b>function</b> %s::connect host($this->oldpal_host)<br>\n", get_class($this));
			$conn = $connect_function($this->oldpal_host);
		}

		if ($conn === false)
		{
if ($this->debugLevel) printf("%s::connect returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		} else
		{
			if ($this->oldpal_database)
			{
if ($this->debugLevel) printf("<b>function</b> %s::connect select $this->oldpal_database<br>\n", get_class($this));
				mysql_select_db($this->oldpal_database, $conn);
			} else
			{
if ($this->debugLevel) printf("<b>function</b> %s::connect select_db returns ERROR<br>\n", get_class($this));
				return $this->raiseError();
			}
		}
		 */
		$conn = 0;

		$this->connection = $conn;
if ($this->debugLevel) printf("<b>function</b> %s::connect returns DB_OK<br>\n", get_class($this));
		return DB_OK;
	}


	function numRows($result)
	{
if ($this->debugLevel) printf("<b>function</b> %s::numRows($result)<br>\n", get_class($this));
		$rows = $this->virt_num_rows($result);
		if ($rows < 0)
		{
if ($this->debugLevel) printf("<b>function</b> %s::numRows returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		}
if ($this->debugLevel) printf("<b>function</b> %s::numRows returns [$rows]<br>\n", get_class($this));
		return $rows;
	}

	function seekRow($result, $rownum = 0)
	{
		if (!$this->virt_data_seek($result, $rownum))
		{
if ($this->debugLevel) printf("<b>function</b> %s::seekRow returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		}
if ($this->debugLevel) printf("<b>function</b> %s::seekRow returns DB_OK<br>\n", get_class($this));
		return DB_OK;
	}

	function nextSeq($table)
	{
		return -1;
	}

	function lastSeq()
	{
		return $this->virt_insert_id();
	}

	function commonRegExp($Str)
	{
		return ("^" . ereg_replace("\*", $this->wildRegExp(), $Str) . "$");
	}

	function commonRegExpWild($Str)
	{
		return ereg_replace("\*", $this->wildRegExp(), $Str);
	}

	function operatorRegExp()
	{
		return "rlike";
	}

	function wildRegExp()
	{
		return ".*";
	}


	function tableList()
	{
		$ret = array_keys($this->tableFields);
/*
printf("tableFields<br>\n");
var_dump($this->tableFields);
printf("tableTypes<br>\n");
var_dump($this->tableTypes);
printf("tableRecords<br>\n");
var_dump($this->tableRecords);
printf("tableName<br>\n");
var_dump($this->tableName);
printf("fieldList<br>\n");
var_dump($this->fieldList);
printf("resultArray<br>\n");
var_dump($this->resultArray);
 */
		return $ret;
	}


	function fieldList($tablename, $withAttr = false)
	{
		$ret = array();

		if (!is_string($tablename))
		{
			// $tablename is index to resultArray
			$ret = $this->resultArray[$tablename]['fieldList'];
			if ($withAttr)
			{
				$tblnm = $this->resultArray[$tablename]['tableName'];
				$tmpArr = $ret;
				$ret = array();
				foreach ($tmpArr as $val)
				{
					$ret[] = array
					(
						'name' => $val,
						'type' => ($this->tableTypes[$tblnm][$val]) ? 'numeric' : 'char',
						'len' => -1,
						'flags' => ($this->tableAutoInc[$tblnm] == $val) ? 'auto_increment' : ''
					);
				}
			}
		} else
		{
			$ret  = $this->tableFields[$tablename];
			if ($withAttr)
			{
				$tmpArr = $ret;
				$ret = array();
				foreach ($tmpArr as $val)
				{
					$ret[] = array
					(
						'name' => $val,
						'type' => ($this->tableTypes[$tablename][$val]) ? 'numeric' : 'char',
						'len' => -1,
						'flags' => ($this->tableAutoInc[$tablename] == $val) ? 'auto_increment' : ''
					);
				}
			}
		}
		return $ret;
	}



// Common functions for Oldpal Object

	function getDebugLevel()
	{
		return $this->debugLevel;
	}

	function getOwner()
	{
		return $this->oldpal_owner;
	}

	function getService()
	{
		return $this->oldpal_service;
	}

	function action($oldpal_resource, $oldpal_action = 'select', $oldpal_getSQL = false)
	{
if ($this->debugLevel) printf("%s::action([$oldpal_resource], [$oldpal_action], [$oldpal_getSQL])<br>\n", get_class($this));
		return DB_oldpal_common::action($oldpal_resource, $oldpal_action, $oldpal_getSQL);
	}

	function display($oldpal_resource, $oldpal_result = -1)
	{
		return DB_oldpal_common::display($oldpal_resource, $oldpal_result);
	}

	function getSelectList($qry, $fmt = '%s:%s', $optsep = '|')
	{
		return DB_oldpal_common::getSelectList($this, $qry, $fmt, $optsep);
	}

	function getSQL($sqlAction)
	{
		return DB_oldpal_common::getSQL($sqlAction);
	}

	function setSQL($sql)
	{
		return DB_oldpal_common::setSQL($sql);
	}

	function quoteString($string)
	{
		return DB_oldpal_common::quoteString($string);
	}

	function unquoteString($string)
	{
		return DB_oldpal_common::unquoteString($string);
	}

	function setDebugLevel($level)
	{
//if ($this->debugLevel || $level) printf("<b>function</b> %s::setDebugLevel([$level])<br>\n", get_class($this));
		$this->debugLevel = $level;
		return DB_OK;
	}
}




}  // OLDPAL_VIRT_PHP
?>
