<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	tree_reset: Initialise all object variables.  Needs to be
 *		called if the tree has changed.
 *
 *	arg%parent - the parent pointer array
 *	arg%root - the index of the node to be set as root (level 0)
 *		Default is the parent of the first node (from this%parent).
 ************************************************************/

function tree_reset
{
	// Clear all elements first
	this%tree_clear;

	// Allow blank root
	if ({arg%function:root|isset}) {
		var this%root = "{arg%root}";
	} else {
		if ({#arg%parent}) var this%root = "{arg%parent|shift}";
	}

	// Must be after initialising this%root as a single-node tree has no parent
	if ({#arg%parent} == 0) return;  // No error; just a null tree

	var this%parent = "(var)arg%parent";
	clear this%parent:{this%root};  // Root has no parent

	var this%current = "{this%root}";

	var allnodes = "(var)this%parent";
	//var allnodes conv="unshift:{this%root}";

	if (!{this%turbo}) {
		foreach (allnodes as node) {
			if ({this%child_{node}|isset} == 0) var this%child_{node} = "(array)";
			var this%child_{node} conv="push:{node:key}";
		}
	} else {
</script>
<?php
		$allnodes = BEE_get("(var)allnodes");
		foreach ($allnodes as $nodeKey => $node) {
			$childNode =& BEE_var("this%child_$node");  // Will create this%child_$node if not defined.
			array_push($childNode, $nodeKey);
		}
?>
<script language="bee">
	}

	//this%tree_setstruct; //node="{this%root}";
	//if ({status%tree_setstruct}) return status="{status%tree_setstruct}" message="{message%tree_setstruct}";
}


function tree_clear
{
	if (!{this%turbo}) {
		foreach (class%this) {
			switch ('{foreach}') {
			case 'parent':
			case 'root':
			case 'current':
				clear this%{foreach};
				break;
			default:
				if ({foreach|foundre:^child_}) clear this%{foreach};
				break;
			}
		}
	} else {
</script>
<?php
		$classThis = BEE_get("(var)class%this");
		foreach ($classThis as $foreach) {
			switch ($foreach) {
			case 'parent':
			case 'root':
			case 'current':
				BEE_clear("this%$foreach");
				break;
			default:
				if (ereg("^child_", $foreach)) BEE_clear("this%$foreach");
				break;
			}
		}
?>
<script language="bee">
	}
}

/************************************************************
 * PRIVATE
 *	tree_setstruct: Initialise internal pointer variables
 ************************************************************/
/*
function tree_setstruct
{
	// Find all the children
	
	// Allow blank node
	//if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";
	if ({#this%parent} == 0) return;  // No error; just a null tree

	var node = "{arg%node}";

	var children = "(array)";
	foreach (this%allnodes)  // Check isset to avoid confusing non-existance with blank
		if ({this%parent:{foreach}|isset} && '{this%parent:{foreach}}' == '{node}')
			var children = "(var)children" conv="push:{foreach}";

	foreach (children) {
		// "last" can be blank
		if ({last:|isset}) {
			var this%elder:{foreach} = "{last}";
			var this%younger:{last} = "{foreach}";
		}
		var last = "{foreach}";
		this%tree_setstruct node="{foreach}";
		if ({status%tree_setstruct}) return status="{status%tree_setstruct}" message="{message%tree_setstruct}";
	}

	if ({#children}) var this%child:{node} = "{children|shift}";
}
 */
</script>
