<?php include("bee/compiler.php"); return; ?>
<script language="bee">
include "common/firewall.bs";

function portal_pathPage
{
	// The PathPage of the current page
	this%DirectoryIndex = "{arg%DirectoryIndex}";
	if ({#this%DirectoryIndex:} == 0) this%DirectoryIndex = "{scheme%portal&DirectoryIndex}";
	if ({#this%DirectoryIndex:} == 0) this%DirectoryIndex = "index.htm";

	this%DirectoryIndexUsed = 0;

	// To get around the form-post-to-virtual-page problem,
	// if sys%form:submitredirectto is there, set it as this%SP
	if ({sys%form:submitredirectto|isset}) {
		this%SP = "{sys%form:submitredirectto|this%convPath}";
		this%PP = "{this%Subpath}{this%SP}";
		sys%default:textfile = "{this%PP}";
		this%SubmitRedirected = 1;
		clear sys%form:submitredirectto;
	} else {
		this%PP = "{arg%PP}";
		if ({#this%PP:} == 0) this%PP = "{sys%urlredirect:pathpage}";
		if ({#this%PP:} == 0) this%PP = "{sys%urlpart:pathpage}";
		if ({#this%PP:} == 0 || '{this%PP}' == '/') {
			this%PP = "/{this%DirectoryIndex}";
			this%DirectoryIndexUsed = 1;
		}
		if (!'{this%RawPP}') this%PP = "{this%PP|this%convPath}";

		this%SP = "{this%PP}";
		if ({#this%Subpath:}) this%SP = "{this%SP|replacere:^{this%Subpath}}";
	}

	if ('{file%{sys%croft:textdir}{this%TextSubdir}{this%SP}&isdir}') {
		this%PP = "{this%PP}/{this%DirectoryIndex}";
		this%SP = "{this%SP}/{this%DirectoryIndex}";
		this%DirectoryIndexUsed = 1;
	}

	// Break down the PP

	// The page number (1 if none; blank if not matching this%PageSyntax)
	this%PageNumber = "";
	// The topic pathpage (the PP without page number)
	this%EntryPP = "";
	this%FamilyPP = "";
	this%PageExt = "";

	this%AddrReg = "{this%PP}" conv="match:{this%PageSyntax}";
	if ({#this%AddrReg} == 0) {
		// Alternative syntax (without extension)
		this%PageSyntax = (var)this%PageSyntaxAlt;
		this%AddrReg = "{this%PP}" conv="match:{this%PageSyntax}";
	}
	if ({#this%AddrReg}) {
		this%FamilyPP = "{this%AddrReg:{this%PageSyntax:family}}";
		this%PageExt = "{this%AddrReg:{this%PageSyntax:pageext}}";
		this%PageNumber = "{this%AddrReg:{this%PageSyntax:pagenum}}";

		// The web pathpage without the page number
		this%EntryPP = "{this%FamilyPP}{this%PageExt}";
		if ({#this%PageNumber:} == 0) this%PageNumber = 1;
	}

	// The subpage appear in the menu (get the pp first then adjust with Subpath)
	this%EntrySP = "{this%EntryPP}";
	this%FamilySP = "{this%FamilyPP}";

	// Adjust both Subpage and Fmaily with Subpath
	if ({#this%Subpath:}) {
		this%EntrySP = "{this%EntrySP|replacere:^{this%Subpath}}";
		this%FamilySP = "{this%FamilySP|replacere:^{this%Subpath}}";
	}
/*
	if ('{this%SP}' == '/' || {#this%SP:} == 0) {
		this%SP = "/{this%DirectoryIndex}";
		this%EntrySP = "/{this%DirectoryIndex}";
		this%FamilySP = "/index";
	}
 */
}


// Do the login or logout depending on arg%auth (which default to sys%form:Submit)
function portal_auth
{
	myarg = (var)arg%function;
	if ({#myarg:auth} == 0) myarg:auth = '{sys%form:Submit}';
	if ({#myarg:username} == 0) myarg:username = '{sys%form:username}';
	if ({#myarg:password} == 0) myarg:password = '{sys%form:password}' convert='unescape:quotes';
	if ({#myarg:realm} == 0) myarg:realm = '{sys%form:realm}';
	if ({#myarg:SessionTimeout} == 0) myarg:SessionTimeout = '{this%SessionTimeout}';
	if ({#myarg:IdleTimeout} == 0) myarg:IdleTimeout = '{this%IdleTimeout}';

	// For security
    clear sys%form:username;
    clear sys%form:password;

	this%JustLoggedIn = 0;
	this%JustLoggedOut = 0;

	st = 0;
	msg = '';
	access {
		switch ('{myarg:auth|lowercase}') {
		case 'logout':
		case 'signout':
		case 'sign-out':
		case 'sign out':
		case 'exit':
			this%LoggedOut:username = "{sys%auth:username}";
			this%LoggedOut:realm = "{sys%auth:realm}";
			this%LoggedOut:loginname = "{sys%auth:loginname}";
			logout;
			msg = '{result%logout:user} logged out\n';
			this%JustLoggedOut = 1;
			break;
		}
	} else {
		switch ('{myarg:auth|lowercase}') {
		case 'login':
		case 'signin':
		case 'sign-in':
		case 'sign in':
		case 'enter':
			// Check AuthFirewall first
			firewallScheme scheme=AuthFirewall ruleset="{myarg:username}" default="DEFAULT";
			if ('{result%firewallScheme}' == 'deny') {
				st = 101;
				msg = "Login denied";
			} else {
				login username="{myarg:username}" password="{myarg:password}" realm="{myarg:realm}";
				st = '{status%login}';
				if ({st}) {
					msg = '{message%login}\n';
				} else {
					if ({#myarg:SessionTimeout}) var sys%session:expiry = "(expr){sys%time} + {myarg:SessionTimeout}";
					if ({#myarg:IdleTimeout}) var sys%session:IdleTimeout = "(expr){myarg:IdleTimeout}";
					this%JustLoggedIn = 1;
				}
			}
			break;
		}
	}

	this%AuthStatus = "{st}";
	this%AuthMessage = "{msg}";
	return status='{st}' message='{msg}';
}
</script>
