<?php include("bee/compiler.php"); return; ?>
<script language="bee">
function portal_setGlobalVars
{
	// Don't do it again
	if ('{this%GlobalVarsSet}') return;

	applKey = "{arg%arg}";
	if ({#scheme%appl&Vars:{applKey}}) {
		foreach ("(array){scheme%appl&Vars:{applKey}}") {
			global {foreach:key};
			{foreach:key} = "{foreach}";
			this%GlobalVarsSet = 1;
		}
	}
}

function portal_prelude
{
	global PortalObjectVersion;

	// If PageInfo is available (from a menu item) check access level
	if ('{#this%PageInfo:AccessLevel}') {
		access (lt {this%PageInfo:AccessLevel}) return;
	}

	// Load the Admin Menu only after the application prelude
	// (in case it modifies scheme%adminmenu&)

	// Discover Prelude Name from scheme%appl&
	foreach (scheme%appl&PageMap) {
		if ({#foreach:} == 0) continue;
//display "if ('this%SP|foundre:^/{foreach:key|replacere:^/+}') (this%SP=[{this%SP}]<br>\n";
		if ('{this%SP|foundre:^/{foreach:key|replacere:^/+}}') {
			this%PageMapName = "{foreach|replacere:^~/,{this%IncludeRoot}}";
//display "Got [{this%PageMapName}]<br>\n";
			include "{this%PageMapName}";
			return;
		}
	}

	// Must check both Prelude and Application to determine %InApplication
	// in %prelude for subsequent sections

	// Discover Prelude Name from scheme%appl&
	foreach (scheme%appl&Prelude) {
		if ({#foreach:} == 0) continue;
//display "if ('this%SP|foundre:^/{foreach:key|replacere:^/+}') (this%SP=[{this%SP}]<br>\n";
		if ('{this%SP|foundre:^/{foreach:key|replacere:^/+}}') {
			this%PreludeName = "{foreach|replacere:^~/,{this%IncludeRoot}}";
//display "Got [{this%PreludeName}]<br>\n";
			this%setGlobalVars "{foreach:key}";
			this%InApplication = 1;
			break;
		}
	}

	// Discover Application Name from scheme%appl&
	// Algorithm in portal_application as well
	foreach (scheme%appl&Application) {
		if ({#foreach:} == 0) continue;
		applSP = "/{foreach:key|replacere:^/+}";  // Normalise to one '/' in front
		if ('{this%SP|foundre:^{applSP}}') {
			this%ApplicationSP = "{applSP}";
			this%ApplicationInclude = "{foreach}";
			// Dummy application is '~' - everything the same except not including the file
			this%ApplicationName = "{this%ApplicationInclude|replacere:^~/,{this%IncludeRoot}}";
			this%setGlobalVars "{foreach:key}";
			this%InApplication = 1;
			break;
		}
	}

	// Not found from scheme%appl&; check the appl directory
	if ({#this%ApplicationName:} == 0) {
		applHTM = "{sys%croft:WWWDir}/appl{this%SP}";
		if ('{file%{applHTM}&exists}') {
			this%ApplicationSP = "{this%SP}";
			this%ApplicationInclude = "{this%IncludeRoot}appl{this%SP}";
			this%ApplicationName = "{this%ApplicationInclude}";
			this%InApplication = 1;
		}
	}

//display "<br><br>this%PreludeName=[{this%PreludeName}]<br>\n";
	if ({#this%PreludeName:}) {
		include "{this%PreludeName}";
	} else {
		if (!'{this%InApplication}') {
			if (!'{this%SP|foundre:\.html?$|\.bee$|\.bs$|\.php.?$|\.aspx?$}') exit;
			// The above is for defending against recursive VP reference
			// (eg missing GIF in the VP redirected back to the VP itself).
			// Exit if it is not in an application and not an HTML
	
			// Now the page is a non-application HTML
			spBS = "{this%SP}";
			spBS = "{spBS|replacere:html?$,bs}";
			applBS = "{sys%croft:WWWDir}/appl{spBS}";
			if ('{file%{applBS}&exists}') {
				this%PreludeName = "{this%IncludeRoot}appl{spBS}";
				this%InApplication = 1;
				include "{this%PreludeName}";
			}
		}
	}

	// Load the Admin Menu from scheme%adminmenu&
	amp = (var)scheme%adminmenu&Page;
	amal = (var)scheme%adminmenu&AccessLevel;
//display "ami=[{ami|list}]<br>\n";
	foreach (amp) {
		allow = "{amal:{foreach:key}|default:admin}";
//display "allow=[{allow}]<br>\n";
		access (ge {allow}) this%AdminMenuItems:{foreach:key} = "{foreach}";
//display "this%AdminMenuItems=[{this%AdminMenuItems|list}]<br>\n";
	}
}


function portal_head
{
	display "{this%JSBegin}";
</script>

var currentItem = '${this%Topic}';

[beeaccess editor]
function showPage(url)
{
	if (url) ${this%PageTargetObject}.location.href = url;
}

function showMenuEditPage()
{
	showPage("${this%Subpath}/menuedit.htm?Topic=" + currentItem);
}

function showOrganizer()
{
	showPage("${this%Subpath}/organizer.htm?Page=${this%SP}");
}

[beeif "!'{this%EasyNew}'"]  <!-- || '{this%InApplication}'"] -->
[beeclear this%AdminMenuItems:newpage]
[beeelse]
function CreateNewPage(np)
{
	newpg = np;
	newpg = '${this%TextSubdir}/' + newpg;
	newpg = newpg.replace(/\/+/g, '/');

	subhead = prompt("Please enter a heading for the new page:", " ");
	if (subhead) {
		<beecall "{this%VirtualPage}" connector="newpage"
			submitredirectto="/newpage.htm"
			pageheadingname="{this%PageHeadingName}:{this%TextItem}"
			pagecode="@newpg" heading="@subhead" phantom="{this%Phantom}">
	}
}

function newpage(result, status, message)
{
	if (status > 0) {
		alert(message);
	} else {
		//alert('Result=[' + result['pagecode'] + ']');
		// Simulate the unique Window Name
		uniqueWinName = result['pagecode'] + '&${this%PageBodyName}:${this%TextItem}';
		uniqueWinName = uniqueWinName.replace(/\W/g, '_');
		//alert('uniqueWinName=[' + uniqueWinName + ']');
		pageCode = result['pagecode'];
		pagePath = "${this%Subpath}" + pageCode;
<beeif if="'{this%Phantom}'">
		textCodeSuffix = "_Phantom";
<beeelse>
		textCodeSuffix = "";
</beeif>
		window.open('${this%SiteURL|replacere:/*$}/${scheme%TextEdit:URL|default:textedit/edit.htm}?pagepath=' + pagePath + '&pagecode=' + pageCode + '&textcode=${this%PageBodyName}&itemcode=${this%TextItem}' + textCodeSuffix + '&pageargs=', uniqueWinName, 'width=780,height=520,top=5,left=3,scrollbars=auto,resizable=yes');
	}
}
[/beeif]

[beeif "!'{this%EasyCopy}'"]  <!-- || '{this%InApplication}'"] -->
[beeclear this%AdminMenuItems:copypage]
[beeelse]
function CopyPage(np)
{
	newpg = np;
	while (!newpg) {
		newpg = prompt("Please enter a file name for the new page (e.g. mypage.htm):", "");
		if (newpg === null) return;
		if (!newpg && !confirm("A file name (e.g. mypage.htm or /mypath/mypage.htm)\nis required for the new page.\n\nDo you want to enter the file name again?")) return;
	}
	newpg = '${this%TextSubdir}/' + newpg;
	newpg = newpg.replace(/\/+/g, '/');

	subhead = prompt("Please enter a heading for the new page:", " ");
	if (subhead) {
		<beecall "{this%VirtualPage}" connector="copypage"
			submitredirectto="/copypage.htm"
			pageheadingname="{this%PageHeadingName}:{this%TextItem}"
			oldpage="{this%TextSubdir}{sys%urlshown:pathpage|replacere:^{this%Subpath}}"
			pagecode="@newpg" heading="@subhead" phantom="{this%Phantom}">
	}
}

function copypage(result, status, message)
{
	if (status > 0) {
		alert(message);
	} else {
		//alert('Result=[' + result['pagecode'] + ']');
		// Simulate the unique Window Name
		uniqueWinName = result['pagecode'] + '&${this%PageBodyName}:${this%TextItem}';
		uniqueWinName = uniqueWinName.replace(/\W/g, '_');
		//alert('uniqueWinName=[' + uniqueWinName + ']');
		pageCode = result['pagecode'];
		pagePath = "${this%Subpath}" + pageCode;
<beeif if="'{this%Phantom}'">
		textCodeSuffix = "_Phantom";
<beeelse>
		textCodeSuffix = "";
</beeif>
		window.open('${this%SiteURL|replacere:/*$}/${scheme%TextEdit:URL|default:textedit/edit.htm}?pagepath=' + pagePath + '&pagecode=' + pageCode + '&textcode=${this%PageBodyName}&itemcode=${this%TextItem}' + textCodeSuffix + '&pageargs=', uniqueWinName, 'width=780,height=520,top=5,left=3,scrollbars=auto,resizable=yes');
	}
}
[/beeif]
[/beeaccess]
<script language="bee">
	display "{this%JSEnd}";
}


function portal_body
{
	//if ('{this%EasyNew}' && !'{this%InApplication}') {
	if ('{this%EasyNew}') {
		if ({#arg%function:iframesrc}) param%connector:src = "{arg%function:iframesrc}";
		connector "newpage";
	}

	//if ('{this%EasyCopy}' && !'{this%InApplication}') {
	if ('{this%EasyCopy}') {
		if ({#arg%function:iframesrc}) param%connector:src = "{arg%function:iframesrc}";
		connector "copypage";
	}
}

// Backward compatibility
function portal_clientScripts
{
	parent {arg%this}%;

	param%head = (var)arg%function;
	this%head;

	param%body = (var)arg%function;
	this%body;
}

// arg%applid - to load a particular application instead of the default
//	(if there're multiple applications on one page)
// arg%applonly - if true and no application run, do not continue to display text
// arg%bgshield - the bgshield argument for text (if non-application)
function portal_application
{
	global PortalObjectVersion;

	// If PageInfo is available (from a menu item) check access level
	/*
	if ('{#this%PageInfo:AccessLevel}') {
		access (lt {this%PageInfo:AccessLevel}) {
			display '<span class="error">Please login first</span>\n';
			return;
		}
	}
	 */

	if (!'{this%PageAccessible}') {
		if ('{function%portal_error:exists}') portal_error error="login";
		else display '<span class="error">Please login first</span>\n';
		return;
	}

	// ApplicationName already found in the %prelude function
	if ({#arg%function:applid}) {
		// Algorithm in portal_prelude as well
		foreach (scheme%appl&Application_{arg%function:applid}) {
			if ({#foreach:} == 0) continue;
			applSP = "/{foreach:key|replacere:^/+}";  // Normalise to one '/' in front
			if ('{this%SP|foundre:^{applSP}}') {
				applicationSP = "{applSP}";
				applicationInclude = "{foreach}";
				// Dummy application is '~' - everything the same except not including the file
				applicationName = "{applicationInclude|replacere:^~/,{this%IncludeRoot}}";
				this%setGlobalVars "{foreach:key}";
				this%InApplication = 1;
				include "{applicationName}";
				return;
			}
		}
	} else if ('{this%ApplicationName}' && '{this%ApplicationName}' != '~') {
		include "{this%ApplicationName}";
		return;
	}

	// Non-application
	if ('{arg%function:applonly}') return;

	// Show "normal" PageBody with the TEACUP magic

	teacupNeeded = 1;
	teacup = (var)scheme%teacup&Attribute;
	if ({#teacup} == 0) teacupNeeded = 0;
	else if ('{text%{this%TextSubdir}{this%SP}&TEACUP}' == 'Disabled') teacupNeeded = 0;

	if ({#arg%function:bgshield}) param%text:bgshield = "{arg%function:bgshield}";

	if ('{teacupNeeded}') param%text:showvar = 1;
//display "param%text=[{param%text|list}]<br>\n";

	// TEA (Text Edit Area) for "PageBody" (of non-application display)
//	this%text "{this%TextSubdir}{this%SP}&{this%PageBodyName}:{this%TextItem}"
	this%text "{this%PageBodyName}{arg%function:applid|precede:_}:{this%TextItem}" default="{this%DefaultText}";

	if ('{teacupNeeded}') {
		teacupVal = (array);
		foreach (teacup) {
			if ({#{foreach:key}:}) teacupVal:{foreach:key} = "{{foreach:key}}";
		}
		// If no attribute value is found, preserve session%teacup;
		if ({#teacupVal}) session%teacup = (var)teacupVal;
	}
}

function portal_adminmenu
{
	if ({#this%AdminMenuItems}) {
		amTB% = new tbody type="adminmenu" file="menu" text="Menu";

		access (admin) {
			if (!'{session%Cell}') {
				this%text "/adminmenu/menu&Menu" hidden=1
					default="Admin Menu";
			}
		}

		amTB%gotTEA;
		if ('{result%gotTEA}') {
			// TEA just saved
			amTB%process (var)session%TextEdit:edittext splitter="|";
			// session%TextEdit cannot be cleared before {PortalObjectName}%text
			clear session%TextEdit;
		}

		amTB%getTBODY;
		display "{amTB%TBODY:Before|replace:~/,{this%Subpath}/}";
		amtbody = "{amTB%TBODY:|this%valueQuote:title}";

		amcap = (var)scheme%adminmenu&Name;
		amttl = (var)scheme%adminmenu&Description;

		foreach (this%AdminMenuItems as am) {
			//amc = "{scheme%appl&AdminMenu_Caption:{am:key}}" conv="split:|";
//display "am:{am:key}=[{am}]<br>\n";
//display "amc=[{amc|list}]<br>\n";
			amHref = "{am}";
			amHrefEscaped = "{amHref}" conv="escape:quotes";
			//amCaption = (var)amc conv="shift";
			//amTitle = (var)amc conv="shift";
			amCaption = "{amcap:{am:key}}";
			amTitle = "{amttl:{am:key}|default:{amCaption}}";
//display "amCaption=[{amCaption}]<br>\n";
//display "amTitle=[{amTitle}]<br>\n";
			if ({#amTitle:} == 0) amTitle = "{amCaption}";
			amItem = "{amtbody}";
			amItem = "{amItem|replace:@Caption,{amCaption|escape:comma}}";
			amItem = "{amItem|replace:@Title,{amTitle|escape:comma}}";
			amItem = "{amItem}" conv="replace:@HrefEscaped,{amHrefEscaped|replace:\\,\\\\}";  // Must come before Href
			amItem = "{amItem|replace:@Href,{amHref}}";
//display "<!-- amHref=[{amHref|escape:quotes}] -->";
			display "{amItem|replace:~/,{this%Subpath}/}";
		}

		display "{amTB%TBODY:After|replace:~/,{this%Subpath}/}";
	}
}

function portal_usermenu
{
	global PortalObjectVersion;

	hndl = "{arg%hndl:|default:hd}";
	menu = "{arg%menu:|default:HorizontalDrop}";
	schm = "{arg%schm:|default:menu}";
	root = "{arg%root}";
	pref = "{arg%pref}";

	include "portal{PortalObjectVersion}/menu/{menu|lowercase}.bs";
	//var scheme%layout/{this%Layout}/{schm}&;
	schmFile = "";
	if ({#this%Layout:}) schmFile = "layout/{this%Layout}/";
	schmFile = "{schmFile}{schm}";
	var scheme%{schmFile}&;
	{hndl}% = new {menu};
/*
	{hndl}%doMenu
		root="{root}"
		menuOffTimeout="{layout/{this%Layout}/menu%MenuOffTimeout}"
		menuIndicator="{layout/{this%Layout}/menu%MenuIndicator}"
		L1=(var)layout/{this%Layout}/{schm}%L1 L2=(var)layout/{this%Layout}/{schm}%L2 L3=(var)layout/{this%Layout}/{schm}%L3 L4=(var)layout/{this%Layout}/{schm}%L4;
 */
	{hndl}%doMenu
		root="{root}"
		pref="{pref}"
		menuOffTimeout="{{schmFile}%MenuOffTimeout}"
		menuIndicator="{{schmFile}%MenuIndicator}"
		L1=(var){schmFile}%L1 L2=(var){schmFile}%L2 L3=(var){schmFile}%L3 L4=(var){schmFile}%L4;
}
</script>
