<?php
include_once("bee/bee.php");
BEE_tagInitialise("xml_init.bs");
?><?php
function BEE_UserFunction_xml_parse()
{
	$BEE_f_startTime = gettimeofday();
	BEE_debugEnterFile("xml_init.bs");
	global $BEE_Var;
	global $BEE_f_contextParent;
	global $BEE_f_contextChild;
	global $BEE_f_nestedLevel;
	global $BEE_debug_active;
	global $BEE_debug_function_time;
	global $PHP_context;
	if (isset($BEE_f_nestedLevel)) $BEE_f_nestedLevel++;
	else $BEE_f_nestedLevel = 1;
	$BEE_f_functionName = "xml_parse";
	$BEE_f_linkName = $BEE_f_functionName;
	$BEE_context = $BEE_f_contextChild;
	$PHP_contextSaved = $PHP_context;
	$PHP_context = $BEE_context;
?><?php
BEE_debugEnterLine(15, $BEE_f_functionName, "function", $BEE_f_contextParent);
global $BEE_Var;
$BEE_paramName = "xml_parse";
if (!isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"])) $BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"] = BEE_tagVarValue("xml_parse", $BEE_f_contextParent);
?><?php
	$BEE_argContext =& BEE_VSC("arg", "function", $BEE_context);
	if (isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName]))
		$BEE_argContext = $BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName];
	foreach ($BEE_argContext as $BEE_key => $BEE_val)
	{
		if ($BEE_key == "function") continue;
		$BEE_argVar =& BEE_VSC("arg", $BEE_key, $BEE_context);
		$BEE_argValue = BEE_tagTypedGet($BEE_val, $BEE_f_contextParent);
		if (is_array($BEE_argValue))
		{
			$BEE_argVar = $BEE_argValue;
		} else
		{
			$BEE_argVar[""] = $BEE_argValue;
			if ($BEE_key == BEE_THISFUNCTION_ATTR_NAME) $BEE_f_linkName = $BEE_argValue;
		}
	}
	if (!isset($BEE_argContext["arg"]))
	{
		$BEE_argArg = "";
		if (strlen($BEE_argContext["new"])) $BEE_argArg = "new";
		else if (strlen($BEE_argContext["thisfunction"])) $BEE_argArg = $BEE_argContext["thisfunction"];
		else if (strlen($BEE_argContext["function"])) $BEE_argArg = $BEE_argContext["function"];
		if (strlen($BEE_argArg))
		{
			$BEE_argArgContext =& BEE_VSC("arg", strtolower($BEE_argArg), $BEE_context);
			BEE_VSC("arg", "arg", $BEE_context);
			$BEE_Var[$BEE_context]["arg"]["arg"] =& $BEE_argArgContext;
		}
	}
	if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0)
		BEE_debugPrint(sprintf("%s[%s entered]
", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName));
	$BEE_f_thisName = $BEE_argContext[BEE_THIS_ATTR_NAME];
	if ($BEE_f_thisName != "")
		$BEE_Var[$BEE_f_contextChild][BEE_THIS_ATTR_NAME] =& $BEE_Var[$BEE_f_contextParent][$BEE_f_thisName];
?><?php
/***** function *****/
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(16, $BEE_f_functionName, "{this%function:xml_clear}", $BEE_context);
global $BEE_Var;
global $BEE_f_contextParent;
global $BEE_f_contextChild;
$BEE_f_contextParentSaved = $BEE_f_contextParent;
$BEE_f_contextChildSaved = $BEE_f_contextChild;
$BEE_f_contextParent = $BEE_context;
$BEE_linkName = strtolower(BEE_tagVarValue("xml_clear", $BEE_f_contextParent));
$BEE_funcName = BEE_tagVarValue("{this%function:xml_clear}", $BEE_f_contextParent);
if ($BEE_funcName == "") $BEE_funcName = "$BEE_linkName";
$BEE_funcName = strtolower($BEE_funcName);
$BEE_f_contextChild = BEE_getContext($BEE_funcName);
$BEE_paramName = $BEE_funcName;
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"] = BEE_tagVarValue("this", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"] = BEE_tagVarValue("xml_clear", $BEE_context);
?><?php
$BEE_status =& BEE_VSC("status", $BEE_linkName, $BEE_f_contextParent);
$BEE_status[""] = '0';
$BEE_message =& BEE_VSC("message", $BEE_linkName, $BEE_f_contextParent);
$BEE_message[""] = '';
$BEE_result =& BEE_VSC("result", strtolower($BEE_linkName), $BEE_f_contextParent);
$BEE_result = array();
BEE_VSC("status", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["status"]["function"] =& $BEE_status;
BEE_VSC("message", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["message"]["function"] =& $BEE_message;
BEE_VSC("result", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["result"]["function"] =& $BEE_result;
$BEE_func = BEE_USERFUNCTION_PREFIX . $BEE_funcName;
if (function_exists($BEE_func))
{
	if ($BEE_linkName != $BEE_paramName && is_array($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]))
	{
		foreach ($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName] as $BEE_key => $BEE_val)
			$BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName][$BEE_key] = $BEE_val;
		unset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]);
	}
	$BEE_func();
	BEE_debugLeaveFile();
}
else if (!meansTrue($BEE_Var[$BEE_context]["param"][$BEE_paramName]["ignoreerror"]))
	BEE_printError("Error: Unknown Function", $BEE_funcName);
$BEE_f_contextParent = $BEE_f_contextParentSaved;
$BEE_f_contextChild = $BEE_f_contextChildSaved;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(17, $BEE_f_functionName, "xmlparse", $BEE_context);
global $BEE_Var;
$BEE_paramName = "xmlparse";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["xmlparse"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["xmlparse"] = BEE_tagVarValue("{arg%xmldoc}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["xml"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["xml"] = BEE_tagVarValue("xmlClass", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["attr"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["attr"] = BEE_tagVarValue("attrClass", $BEE_context);
?><?php
/***** xmlparse *****/
BEE_tagLibXMLParse($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(18, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("{status%xmlparse}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(18, $BEE_f_functionName, "return", $BEE_context);
global $BEE_Var;
$BEE_paramName = "return";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["status"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["status"] = BEE_tagVarValue("{status%xmlparse}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["message"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["message"] = BEE_tagVarValue("{message%xmlparse}", $BEE_context);
?><?php
/***** return *****/
global $BEE_s_stackPointer;
if (isset($BEE_loopReturnComp)) $BEE_s_stackPointer -= $BEE_loopReturnComp;
global $BEE_f_nestedLevel;
global $BEE_debug_function_time;
global $BEE_debug_active;
global $PHP_context;
if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0 && is_array($BEE_f_startTime))
{
	$BEE_f_stopTime = gettimeofday();
	$BEE_dura = ($BEE_f_stopTime["sec"] - $BEE_f_startTime["sec"]) * 1000;
	$BEE_dura = ($BEE_f_stopTime["usec"] - $BEE_f_startTime["usec"]) / 1000 + $BEE_dura;
	BEE_debugPrint(sprintf("%s[%s returns in %d ms]\n", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName, $BEE_dura));
}
if (isset($BEE_f_nestedLevel) && $BEE_f_nestedLevel > 0) $BEE_f_nestedLevel--;
BEE_tagLibReturn_beforeReturn($BEE_context);
$PHP_context = $PHP_contextSaved;
return;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
BEE_debugEnterLine(21, $BEE_f_functionName, "var parentLevelArr", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("parentLevelArr", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("(array)", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(22, $BEE_f_functionName, "var parentPointerArr", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("parentPointerArr", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("(array)", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(23, $BEE_f_functionName, "var allnodes", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("allnodes", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("(array)", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(25, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("!{this%turbo}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(26, $BEE_f_functionName, "foreach", $BEE_context);
global $BEE_Var;
$BEE_paramName = "foreach";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["foreach"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["foreach"] = BEE_tagVarValue("(array){class%list:xmlClass}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["source"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["source"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("node", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["as"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["as"] = BEE_tagVarValue("foreach", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiter"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiter"] = BEE_tagVarValue("1000", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiterations"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiterations"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** foreach *****/
global $BEE_s_stackPointer;
global $BEE_s_break;
if (isset($BEE_s_stackPointer)) $BEE_s_stackPointer++;
else $BEE_s_stackPointer = 0;
if (isset($BEE_loopReturnComp)) $BEE_loopReturnComp++;
else $BEE_loopReturnComp = 1;
BEE_tagLibForeach_beforeLoop($BEE_context);
while (true)
{
	BEE_tagLibForeach_inLoop($BEE_context);
	if ($BEE_s_break[$BEE_s_stackPointer])
	{
		$BEE_s_stackPointer--;
		if ($BEE_s_stackPointer < 0) unset($BEE_s_stackPointer);
		if (isset($BEE_loopReturnComp)) $BEE_loopReturnComp--;
		else $BEE_loopReturnComp = 0;
		break;
	}
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(28, $BEE_f_functionName, "var this%xml_{node}", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("this%xml_{node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("(var)xmlClass%{node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(29, $BEE_f_functionName, "var level", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("level", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("{this%xml_{node}:level}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(30, $BEE_f_functionName, "clear", $BEE_context);
global $BEE_Var;
$BEE_paramName = "clear";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["clear"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["clear"] = BEE_tagVarValue("this%xml_{node}:level", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** clear *****/
BEE_tagLibClear($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(33, $BEE_f_functionName, "var type", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("type", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("{this%xml_{node}:type}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(35, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("'{type}' == 'open' || '{type}' == 'complete'", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(35, $BEE_f_functionName, "var parentLevelArr:{level}", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("parentLevelArr:{level}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("{node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
BEE_debugEnterLine(36, $BEE_f_functionName, "var parentNode", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("parentNode", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("{parentLevelArr:{level|dec}}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(37, $BEE_f_functionName, "var parentPointerArr:{node}", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("parentPointerArr:{node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("{parentNode}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(39, $BEE_f_functionName, "var allnodes", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("allnodes", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("push:{node}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
BEE_debugEnterLine(43, $BEE_f_functionName, "foreach", $BEE_context);
global $BEE_Var;
$BEE_paramName = "foreach";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["foreach"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["foreach"] = BEE_tagVarValue("(array){class%list:attrClass}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["source"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["source"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["as"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["as"] = BEE_tagVarValue("foreach", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiter"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiter"] = BEE_tagVarValue("1000", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiterations"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiterations"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** foreach *****/
global $BEE_s_stackPointer;
global $BEE_s_break;
if (isset($BEE_s_stackPointer)) $BEE_s_stackPointer++;
else $BEE_s_stackPointer = 0;
if (isset($BEE_loopReturnComp)) $BEE_loopReturnComp++;
else $BEE_loopReturnComp = 1;
BEE_tagLibForeach_beforeLoop($BEE_context);
while (true)
{
	BEE_tagLibForeach_inLoop($BEE_context);
	if ($BEE_s_break[$BEE_s_stackPointer])
	{
		$BEE_s_stackPointer--;
		if ($BEE_s_stackPointer < 0) unset($BEE_s_stackPointer);
		if (isset($BEE_loopReturnComp)) $BEE_loopReturnComp--;
		else $BEE_loopReturnComp = 0;
		break;
	}
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(44, $BEE_f_functionName, "var this%attr_value_{foreach}", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("this%attr_value_{foreach}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("(var)attrClass%{foreach}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
} else {
?><?php
BEE_debugEnterLine(46, $BEE_f_functionName, "else", $BEE_context);
global $BEE_Var;
$BEE_paramName = "else";
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>

<?php
		$allnodes =& BEE_var("allnodes");
		$arr = BEE_get("(array){class%list:xmlClass}");
		foreach ($arr as $node) {
			BEE_set("this%xml_$node", BEE_get("(var)xmlClass%$node"));
			BEE_set("level", BEE_get("{this%xml_$node:level}"));
			BEE_clear("this%xml_$node:level");  // Don't need it after this
	
			// Parent
			$type =& BEE_var("type");
			$type = BEE_get("{this%xml_$node:type}");
			if ($type == 'open' || $type == 'complete')
				BEE_set("parentLevelArr:{level}", $node);
			BEE_set("parentNode", BEE_get("{parentLevelArr:{level|dec}}"));
			BEE_set("parentPointerArr:$node", BEE_get("{parentNode}"));

			array_push($allnodes, $node);
		}
	
		// "declass" attrClass
		$arr = BEE_get("(array){class%list:attrClass}");
		foreach ($arr as $foreach) {
			BEE_set("this%attr_value_$foreach", BEE_get("(var)attrClass%$foreach"));
		}
?>
<?php
}
?><?php
BEE_debugEnterLine(76, $BEE_f_functionName, "{this%function:tree_reset}", $BEE_context);
global $BEE_Var;
global $BEE_f_contextParent;
global $BEE_f_contextChild;
$BEE_f_contextParentSaved = $BEE_f_contextParent;
$BEE_f_contextChildSaved = $BEE_f_contextChild;
$BEE_f_contextParent = $BEE_context;
$BEE_linkName = strtolower(BEE_tagVarValue("tree_reset", $BEE_f_contextParent));
$BEE_funcName = BEE_tagVarValue("{this%function:tree_reset}", $BEE_f_contextParent);
if ($BEE_funcName == "") $BEE_funcName = "$BEE_linkName";
$BEE_funcName = strtolower($BEE_funcName);
$BEE_f_contextChild = BEE_getContext($BEE_funcName);
$BEE_paramName = $BEE_funcName;
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["parent"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["parent"] = BEE_tagVarValue("(var)parentPointerArr", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"] = BEE_tagVarValue("this", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"] = BEE_tagVarValue("tree_reset", $BEE_context);
?><?php
$BEE_status =& BEE_VSC("status", $BEE_linkName, $BEE_f_contextParent);
$BEE_status[""] = '0';
$BEE_message =& BEE_VSC("message", $BEE_linkName, $BEE_f_contextParent);
$BEE_message[""] = '';
$BEE_result =& BEE_VSC("result", strtolower($BEE_linkName), $BEE_f_contextParent);
$BEE_result = array();
BEE_VSC("status", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["status"]["function"] =& $BEE_status;
BEE_VSC("message", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["message"]["function"] =& $BEE_message;
BEE_VSC("result", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["result"]["function"] =& $BEE_result;
$BEE_func = BEE_USERFUNCTION_PREFIX . $BEE_funcName;
if (function_exists($BEE_func))
{
	if ($BEE_linkName != $BEE_paramName && is_array($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]))
	{
		foreach ($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName] as $BEE_key => $BEE_val)
			$BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName][$BEE_key] = $BEE_val;
		unset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]);
	}
	$BEE_func();
	BEE_debugLeaveFile();
}
else if (!meansTrue($BEE_Var[$BEE_context]["param"][$BEE_paramName]["ignoreerror"]))
	BEE_printError("Error: Unknown Function", $BEE_funcName);
$BEE_f_contextParent = $BEE_f_contextParentSaved;
$BEE_f_contextChild = $BEE_f_contextChildSaved;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
/***** return *****/
global $BEE_s_stackPointer;
if (isset($BEE_loopReturnComp)) $BEE_s_stackPointer -= $BEE_loopReturnComp;
global $BEE_f_nestedLevel;
global $BEE_debug_function_time;
global $BEE_debug_active;
global $PHP_context;
if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0 && is_array($BEE_f_startTime))
{
	$BEE_f_stopTime = gettimeofday();
	$BEE_dura = ($BEE_f_stopTime["sec"] - $BEE_f_startTime["sec"]) * 1000;
	$BEE_dura = ($BEE_f_stopTime["usec"] - $BEE_f_startTime["usec"]) / 1000 + $BEE_dura;
	BEE_debugPrint(sprintf("%s[%s returns in %d ms]\n", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName, $BEE_dura));
}
if (isset($BEE_f_nestedLevel) && $BEE_f_nestedLevel > 0) $BEE_f_nestedLevel--;
BEE_tagLibReturn_beforeReturn($BEE_context);
$PHP_context = $PHP_contextSaved;
return;
?><?php
}
?><?php
function BEE_UserFunction_xml_reset()
{
	$BEE_f_startTime = gettimeofday();
	BEE_debugEnterFile("xml_init.bs");
	global $BEE_Var;
	global $BEE_f_contextParent;
	global $BEE_f_contextChild;
	global $BEE_f_nestedLevel;
	global $BEE_debug_active;
	global $BEE_debug_function_time;
	global $PHP_context;
	if (isset($BEE_f_nestedLevel)) $BEE_f_nestedLevel++;
	else $BEE_f_nestedLevel = 1;
	$BEE_f_functionName = "xml_reset";
	$BEE_f_linkName = $BEE_f_functionName;
	$BEE_context = $BEE_f_contextChild;
	$PHP_contextSaved = $PHP_context;
	$PHP_context = $BEE_context;
?><?php
BEE_debugEnterLine(88, $BEE_f_functionName, "function", $BEE_f_contextParent);
global $BEE_Var;
$BEE_paramName = "xml_reset";
if (!isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"])) $BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"] = BEE_tagVarValue("xml_reset", $BEE_f_contextParent);
?><?php
	$BEE_argContext =& BEE_VSC("arg", "function", $BEE_context);
	if (isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName]))
		$BEE_argContext = $BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName];
	foreach ($BEE_argContext as $BEE_key => $BEE_val)
	{
		if ($BEE_key == "function") continue;
		$BEE_argVar =& BEE_VSC("arg", $BEE_key, $BEE_context);
		$BEE_argValue = BEE_tagTypedGet($BEE_val, $BEE_f_contextParent);
		if (is_array($BEE_argValue))
		{
			$BEE_argVar = $BEE_argValue;
		} else
		{
			$BEE_argVar[""] = $BEE_argValue;
			if ($BEE_key == BEE_THISFUNCTION_ATTR_NAME) $BEE_f_linkName = $BEE_argValue;
		}
	}
	if (!isset($BEE_argContext["arg"]))
	{
		$BEE_argArg = "";
		if (strlen($BEE_argContext["new"])) $BEE_argArg = "new";
		else if (strlen($BEE_argContext["thisfunction"])) $BEE_argArg = $BEE_argContext["thisfunction"];
		else if (strlen($BEE_argContext["function"])) $BEE_argArg = $BEE_argContext["function"];
		if (strlen($BEE_argArg))
		{
			$BEE_argArgContext =& BEE_VSC("arg", strtolower($BEE_argArg), $BEE_context);
			BEE_VSC("arg", "arg", $BEE_context);
			$BEE_Var[$BEE_context]["arg"]["arg"] =& $BEE_argArgContext;
		}
	}
	if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0)
		BEE_debugPrint(sprintf("%s[%s entered]
", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName));
	$BEE_f_thisName = $BEE_argContext[BEE_THIS_ATTR_NAME];
	if ($BEE_f_thisName != "")
		$BEE_Var[$BEE_f_contextChild][BEE_THIS_ATTR_NAME] =& $BEE_Var[$BEE_f_contextParent][$BEE_f_thisName];
?><?php
/***** function *****/
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(89, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("{#arg:namespace}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(89, $BEE_f_functionName, "var this%namespace", $BEE_context);
global $BEE_Var;
$BEE_paramName = "var";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue("this%namespace", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["value"] = BEE_tagVarValue("{arg%namespace}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["conv"] = BEE_tagVarValue("", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["convert"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["default"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["display"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** var *****/
BEE_tagLibVar($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
BEE_debugEnterLine(91, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("{this%root|isset}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(91, $BEE_f_functionName, "{this%function:xml_setstruct}", $BEE_context);
global $BEE_Var;
global $BEE_f_contextParent;
global $BEE_f_contextChild;
$BEE_f_contextParentSaved = $BEE_f_contextParent;
$BEE_f_contextChildSaved = $BEE_f_contextChild;
$BEE_f_contextParent = $BEE_context;
$BEE_linkName = strtolower(BEE_tagVarValue("xml_setstruct", $BEE_f_contextParent));
$BEE_funcName = BEE_tagVarValue("{this%function:xml_setstruct}", $BEE_f_contextParent);
if ($BEE_funcName == "") $BEE_funcName = "$BEE_linkName";
$BEE_funcName = strtolower($BEE_funcName);
$BEE_f_contextChild = BEE_getContext($BEE_funcName);
$BEE_paramName = $BEE_funcName;
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["node"] = BEE_tagVarValue("{this%root}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["namespace"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["namespace"] = BEE_tagVarValue("{this%namespace}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["this"] = BEE_tagVarValue("this", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["thisfunction"] = BEE_tagVarValue("xml_setstruct", $BEE_context);
?><?php
$BEE_status =& BEE_VSC("status", $BEE_linkName, $BEE_f_contextParent);
$BEE_status[""] = '0';
$BEE_message =& BEE_VSC("message", $BEE_linkName, $BEE_f_contextParent);
$BEE_message[""] = '';
$BEE_result =& BEE_VSC("result", strtolower($BEE_linkName), $BEE_f_contextParent);
$BEE_result = array();
BEE_VSC("status", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["status"]["function"] =& $BEE_status;
BEE_VSC("message", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["message"]["function"] =& $BEE_message;
BEE_VSC("result", "function", $BEE_f_contextChild);
$BEE_Var[$BEE_f_contextChild]["result"]["function"] =& $BEE_result;
$BEE_func = BEE_USERFUNCTION_PREFIX . $BEE_funcName;
if (function_exists($BEE_func))
{
	if ($BEE_linkName != $BEE_paramName && is_array($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]))
	{
		foreach ($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName] as $BEE_key => $BEE_val)
			$BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName][$BEE_key] = $BEE_val;
		unset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_linkName]);
	}
	$BEE_func();
	BEE_debugLeaveFile();
}
else if (!meansTrue($BEE_Var[$BEE_context]["param"][$BEE_paramName]["ignoreerror"]))
	BEE_printError("Error: Unknown Function", $BEE_funcName);
$BEE_f_contextParent = $BEE_f_contextParentSaved;
$BEE_f_contextChild = $BEE_f_contextChildSaved;
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
/***** return *****/
global $BEE_s_stackPointer;
if (isset($BEE_loopReturnComp)) $BEE_s_stackPointer -= $BEE_loopReturnComp;
global $BEE_f_nestedLevel;
global $BEE_debug_function_time;
global $BEE_debug_active;
global $PHP_context;
if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0 && is_array($BEE_f_startTime))
{
	$BEE_f_stopTime = gettimeofday();
	$BEE_dura = ($BEE_f_stopTime["sec"] - $BEE_f_startTime["sec"]) * 1000;
	$BEE_dura = ($BEE_f_stopTime["usec"] - $BEE_f_startTime["usec"]) / 1000 + $BEE_dura;
	BEE_debugPrint(sprintf("%s[%s returns in %d ms]\n", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName, $BEE_dura));
}
if (isset($BEE_f_nestedLevel) && $BEE_f_nestedLevel > 0) $BEE_f_nestedLevel--;
BEE_tagLibReturn_beforeReturn($BEE_context);
$PHP_context = $PHP_contextSaved;
return;
?><?php
}
?><?php
function BEE_UserFunction_xml_clear()
{
	$BEE_f_startTime = gettimeofday();
	BEE_debugEnterFile("xml_init.bs");
	global $BEE_Var;
	global $BEE_f_contextParent;
	global $BEE_f_contextChild;
	global $BEE_f_nestedLevel;
	global $BEE_debug_active;
	global $BEE_debug_function_time;
	global $PHP_context;
	if (isset($BEE_f_nestedLevel)) $BEE_f_nestedLevel++;
	else $BEE_f_nestedLevel = 1;
	$BEE_f_functionName = "xml_clear";
	$BEE_f_linkName = $BEE_f_functionName;
	$BEE_context = $BEE_f_contextChild;
	$PHP_contextSaved = $PHP_context;
	$PHP_context = $BEE_context;
?><?php
BEE_debugEnterLine(102, $BEE_f_functionName, "function", $BEE_f_contextParent);
global $BEE_Var;
$BEE_paramName = "xml_clear";
if (!isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"])) $BEE_Var[$BEE_f_contextParent]["param"][$BEE_paramName]["function"] = BEE_tagVarValue("xml_clear", $BEE_f_contextParent);
?><?php
	$BEE_argContext =& BEE_VSC("arg", "function", $BEE_context);
	if (isset($BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName]))
		$BEE_argContext = $BEE_Var[$BEE_f_contextParent]["param"][$BEE_f_functionName];
	foreach ($BEE_argContext as $BEE_key => $BEE_val)
	{
		if ($BEE_key == "function") continue;
		$BEE_argVar =& BEE_VSC("arg", $BEE_key, $BEE_context);
		$BEE_argValue = BEE_tagTypedGet($BEE_val, $BEE_f_contextParent);
		if (is_array($BEE_argValue))
		{
			$BEE_argVar = $BEE_argValue;
		} else
		{
			$BEE_argVar[""] = $BEE_argValue;
			if ($BEE_key == BEE_THISFUNCTION_ATTR_NAME) $BEE_f_linkName = $BEE_argValue;
		}
	}
	if (!isset($BEE_argContext["arg"]))
	{
		$BEE_argArg = "";
		if (strlen($BEE_argContext["new"])) $BEE_argArg = "new";
		else if (strlen($BEE_argContext["thisfunction"])) $BEE_argArg = $BEE_argContext["thisfunction"];
		else if (strlen($BEE_argContext["function"])) $BEE_argArg = $BEE_argContext["function"];
		if (strlen($BEE_argArg))
		{
			$BEE_argArgContext =& BEE_VSC("arg", strtolower($BEE_argArg), $BEE_context);
			BEE_VSC("arg", "arg", $BEE_context);
			$BEE_Var[$BEE_context]["arg"]["arg"] =& $BEE_argArgContext;
		}
	}
	if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0)
		BEE_debugPrint(sprintf("%s[%s entered]
", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName));
	$BEE_f_thisName = $BEE_argContext[BEE_THIS_ATTR_NAME];
	if ($BEE_f_thisName != "")
		$BEE_Var[$BEE_f_contextChild][BEE_THIS_ATTR_NAME] =& $BEE_Var[$BEE_f_contextParent][$BEE_f_thisName];
?><?php
/***** function *****/
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(104, $BEE_f_functionName, "foreach", $BEE_context);
global $BEE_Var;
$BEE_paramName = "foreach";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["foreach"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["foreach"] = BEE_tagVarValue("(array){class%list:this}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["source"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["source"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue(null, $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["as"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["as"] = BEE_tagVarValue("foreach", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiter"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiter"] = BEE_tagVarValue("1000", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiterations"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["maxiterations"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** foreach *****/
global $BEE_s_stackPointer;
global $BEE_s_break;
if (isset($BEE_s_stackPointer)) $BEE_s_stackPointer++;
else $BEE_s_stackPointer = 0;
if (isset($BEE_loopReturnComp)) $BEE_loopReturnComp++;
else $BEE_loopReturnComp = 1;
BEE_tagLibForeach_beforeLoop($BEE_context);
while (true)
{
	BEE_tagLibForeach_inLoop($BEE_context);
	if ($BEE_s_break[$BEE_s_stackPointer])
	{
		$BEE_s_stackPointer--;
		if ($BEE_s_stackPointer < 0) unset($BEE_s_stackPointer);
		if (isset($BEE_loopReturnComp)) $BEE_loopReturnComp--;
		else $BEE_loopReturnComp = 0;
		break;
	}
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(104, $BEE_f_functionName, "if", $BEE_context);
global $BEE_Var;
$BEE_paramName = "if";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["if"] = BEE_tagVarValue("{foreach|foundre:^xml_} || {foreach|foundre:^attr_}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["condition"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** if *****/
BEE_tagLibIf_beforeIf($BEE_context);
$BEE_if_resultVar =& BEE_VSC("result", "if", $BEE_context);
if ($BEE_if_resultVar["istrue"])
{
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
BEE_debugEnterLine(104, $BEE_f_functionName, "clear", $BEE_context);
global $BEE_Var;
$BEE_paramName = "clear";
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["clear"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["clear"] = BEE_tagVarValue("this%{foreach}", $BEE_context);
if (!isset($BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"])) $BEE_Var[$BEE_context]["param"][$BEE_paramName]["var"] = BEE_tagVarValue(null, $BEE_context);
?><?php
/***** clear *****/
BEE_tagLibClear($BEE_context);
?><?php
$BEE_Var[$BEE_context]["param"][$BEE_paramName] = array();
?>
<?php
}
?><?php
}
?><?php
/***** return *****/
global $BEE_s_stackPointer;
if (isset($BEE_loopReturnComp)) $BEE_s_stackPointer -= $BEE_loopReturnComp;
global $BEE_f_nestedLevel;
global $BEE_debug_function_time;
global $BEE_debug_active;
global $PHP_context;
if ($BEE_debug_active && $BEE_debug_function_time >= $BEE_f_nestedLevel && $BEE_f_nestedLevel > 0 && is_array($BEE_f_startTime))
{
	$BEE_f_stopTime = gettimeofday();
	$BEE_dura = ($BEE_f_stopTime["sec"] - $BEE_f_startTime["sec"]) * 1000;
	$BEE_dura = ($BEE_f_stopTime["usec"] - $BEE_f_startTime["usec"]) / 1000 + $BEE_dura;
	BEE_debugPrint(sprintf("%s[%s returns in %d ms]\n", str_repeat(BEE_TAG_DEBUG_FUNCTION_INDENT, $BEE_f_nestedLevel - 1), $BEE_f_linkName, $BEE_dura));
}
if (isset($BEE_f_nestedLevel) && $BEE_f_nestedLevel > 0) $BEE_f_nestedLevel--;
BEE_tagLibReturn_beforeReturn($BEE_context);
$PHP_context = $PHP_contextSaved;
return;
?><?php
}
?>
<?php
BEE_tagFinalise();
?>
